## videoscale videoscale — Resizes video |

## Properties

gboolean | add-borders | Read / Write
gboolean | dither | Read / Write / Construct
gdouble | envelope | Read / Write / Construct
GstVideoScaleMethod | method | Read / Write
gdouble | sharpen | Read / Write / Construct
gdouble | sharpness | Read / Write / Construct

## Types and Values

struct | GstVideoScale
enum | GstVideoScaleMethod

## Object Hierarchy

        GObject
        ╰── GInitiallyUnowned
            ╰── GstObject
                ╰── GstElement
                    ╰── GstBaseTransform
                        ╰── GstVideoFilter
                            ╰── GstVideoScale

## Description

This element resizes video frames. By default the element will try to negotiate to the same size on the source and sinkpad so that no scaling is needed. It is therefore safe to insert this element in a pipeline to get more robust behaviour without any cost if no scaling is needed.

This element supports a wide range of color spaces including various YUV and RGB formats and is therefore generally able to operate anywhere in a pipeline.

### Example pipelines

    1
    gst-launch -v filesrc location=videotestsrc.ogg ! oggdemux ! theoradec ! videoconvert ! videoscale ! ximagesink

Decode an Ogg/Theora and display the video using ximagesink. Since ximagesink cannot perform scaling, the video scaling will be performed by videoscale when you resize the video window. To create the test Ogg/Theora file refer to the documentation of theoraenc.

    1
    gst-launch -v filesrc location=videotestsrc.ogg ! oggdemux ! theoradec ! videoscale ! video/x-raw, width=50 ! xvimagesink

Decode an Ogg/Theora and display the video using xvimagesink with a width of 50.

## Synopsis

### Element Information

plugin | videoscale
author | Wim Taymans <wim.taymans@chello.be>
class | Filter/Converter/Video/Scaler

### Element Pads

name | sink
direction | sink
presence | always
details | video/x-raw, format=(string){ I420, YV12, YUY2, UYVY, AYUV, RGBx, BGRx, xRGB, xBGR, RGBA, BGRA, ARGB, ABGR, RGB, BGR, Y41B, Y42B, YVYU, Y444, GRAY8, GRAY16_BE, GRAY16_LE, v308, RGB16, RGB15, ARGB64, AYUV64, NV12 }, width=(int)[ 1, 32767 ], height=(int)[ 1, 32767 ], framerate=(fraction)[ 0/1, 2147483647/1 ]
| video/x-raw(ANY), format=(string){ I420, YV12, YUY2, UYVY, AYUV, RGBx, BGRx, xRGB, xBGR, RGBA, BGRA, ARGB, ABGR, RGB, BGR, Y41B, Y42B, YVYU, Y444, GRAY8, GRAY16_BE, GRAY16_LE, v308, RGB16, RGB15, ARGB64, AYUV64, NV12 }, width=(int)[ 1, 32767 ], height=(int)[ 1, 32767 ], framerate=(fraction)[ 0/1, 2147483647/1 ]

name | src
direction | source
presence | always
details | video/x-raw, format=(string){ I420, YV12, YUY2, UYVY, AYUV, RGBx, BGRx, xRGB, xBGR, RGBA, BGRA, ARGB, ABGR, RGB, BGR, Y41B, Y42B, YVYU, Y444, GRAY8, GRAY16_BE, GRAY16_LE, v308, RGB16, RGB15, ARGB64, AYUV64, NV12 }, width=(int)[ 1, 32767 ], height=(int)[ 1, 32767 ], framerate=(fraction)[ 0/1, 2147483647/1 ]
| video/x-raw(ANY), format=(string){ I420, YV12, YUY2, UYVY, AYUV, RGBx, BGRx, xRGB, xBGR, RGBA, BGRA, ARGB, ABGR, RGB, BGR, Y41B, Y42B, YVYU, Y444, GRAY8, GRAY16_BE, GRAY16_LE, v308, RGB16, RGB15, ARGB64, AYUV64, NV12 }, width=(int)[ 1, 32767 ], height=(int)[ 1, 32767 ], framerate=(fraction)[ 0/1, 2147483647/1 ]

## Functions

## Types and Values

### struct GstVideoScale

    struct GstVideoScale;

Opaque data structure

### enum GstVideoScaleMethod

The videoscale method to use.

#### Members

GST_VIDEO_SCALE_NEAREST | use nearest neighbour scaling (fast and ugly) |
GST_VIDEO_SCALE_BILINEAR | use bilinear scaling (slower but prettier). |
GST_VIDEO_SCALE_4TAP | use a 4-tap filter for scaling (slow). |
GST_VIDEO_SCALE_LANCZOS | use a multitap Lanczos filter for scaling (slow). |

## Property Details

### The `“add-borders”` property

      “add-borders”              gboolean

Add black borders if necessary to keep the display aspect ratio.

Flags: Read / Write

Default value: TRUE

### The `“dither”` property

      “dither”                   gboolean

Add dither (only used for Lanczos method).

Flags: Read / Write / Construct

Default value: FALSE

### The `“envelope”` property

      “envelope”                 gdouble

Size of filter envelope.

Flags: Read / Write / Construct

Allowed values: [1,5]

Default value: 2

### The `“method”` property

      “method”                   GstVideoScaleMethod

method.

Flags: Read / Write

Default value: Bilinear

### The `“sharpen”` property

      “sharpen”                  gdouble

Sharpening.

Flags: Read / Write / Construct

Allowed values: [0,1]

Default value: 0

### The `“sharpness”` property

      “sharpness”                gdouble

Sharpness of filter.

Flags: Read / Write / Construct

Allowed values: [0.5,1.5]

Default value: 1

## See Also

videorate, videoconvert